local assets=
{
	Asset("ANIM", "anim/smallmushroom.zip"),
	Asset("ATLAS", "images/inventoryimages/smallmushroom.xml"),
	Asset("IMAGE", "images/inventoryimages/smallmushroom.tex"),
}

local prefabs =
{
	"spoiled_food",
}

local function oneaten(inst, eater)
	if eater.shroomed then
--print("table already set")
	else
--print("setting table")
		eater.shroomed={}
		eater.shroomed.scale=0
		eater:ListenForEvent("unshroom", function(inst)
			eater:DoTaskInTime(eater.shroomed.time, function(inst)
--print("shroom over")
				eater.components.combat.damagemultiplier=eater.shroomed.defaultdamagemultiplier
				eater.components.health.maxhealth=eater.shroomed.defaultmaxhealth
				eater.components.health:DoDelta(eater.shroomed.defaultmaxhealth)
				eater:DoTaskInTime(0, function(inst)
					eater.Transform:SetScale(1,1,1)
TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_up")
				end)
				eater:DoTaskInTime(.25, function(inst)
					eater.Transform:SetScale(eater.shroomed.scale,eater.shroomed.scale,eater.shroomed.scale)
				end)
				eater:DoTaskInTime(.5, function(inst)
					eater.Transform:SetScale(1,1,1)
TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_up")
				end)
				eater:DoTaskInTime(.75, function(inst)
					eater.Transform:SetScale(eater.shroomed.scale,eater.shroomed.scale,eater.shroomed.scale)
				end)
				eater:DoTaskInTime(1, function(inst)
					eater.Transform:SetScale(1,1,1)
TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_up")
				end)
				eater.shroomed.issmallshroomed=false
				eater.shroomed.isbigshroomed=false
			end)
				return
		end)
	end
	if eater.shroomed.time then
--print("adding time")
		eater.shroomed.time=eater.shroomed.time-20
	else
--print("setting up timer")
		eater.shroomed.time=-20
		eater:DoPeriodicTask(1, function(inst)
			if eater.shroomed.time>0 then
				eater.shroomed.time=eater.shroomed.time-1
			end
			if eater.shroomed.time<0 then
				eater.shroomed.time=eater.shroomed.time+1
			end
			if eater.shroomed.time==0 then
				if eater.shroomed.isbigshroomed==true or eater.shroomed.issmallshroomed==true then
					eater:PushEvent("unshroom")
				end
			end
--local temp=eater.components.combat.damagemultiplier or 1
--print("scale: " .. eater.shroomed.scale .. " time: " .. eater.shroomed.time .. " damage: " .. temp)
		end)
	end
	if eater.shroomed.isbigshroomed or eater.shroomed.issmallshroomed then
	else
--print("setting up shroomed values")
		eater.shroomed.isbigshroomed=false
		eater.shroomed.issmallshroomed=false
		if eater.components.combat then
			eater.shroomed.defaultdamagemultiplier=eater.components.combat.damagemultiplier or 1
		end
		if eater.components.health then
			eater.shroomed.defaultmaxhealth=eater.components.health.maxhealth
		end
	end
	eater.shroomed.scale=.5
	if eater.shroomed.issmallshroomed==false and eater.shroomed.time<0 then
		eater.shroomed.isbigshroomed=false
		eater.shroomed.issmallshroomed=true
		if eater.shroomed.isbigshroomed==false then
			if eater.components.combat.damagemultiplier then
				eater.components.combat.damagemultiplier=eater.shroomed.defaultdamagemultiplier*eater.shroomed.scale
			else
				eater.components.combat.damagemultiplier=eater.shroomed.scale
			end
			if eater.components.health then
				eater.components.health.maxhealth=eater.shroomed.defaultmaxhealth*eater.shroomed.scale
				eater.components.health:DoDelta(eater.shroomed.defaultmaxhealth)
			end
		end
		eater:DoTaskInTime(0, function(inst)
			eater.Transform:SetScale(eater.shroomed.scale,eater.shroomed.scale,eater.shroomed.scale)
TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_down")
		end)
		eater:DoTaskInTime(.25, function(inst)
			eater.Transform:SetScale(1,1,1)
		end)
		eater:DoTaskInTime(.5, function(inst)
			eater.Transform:SetScale(eater.shroomed.scale,eater.shroomed.scale,eater.shroomed.scale)
TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_down")
		end)
		eater:DoTaskInTime(.75, function(inst)
			eater.Transform:SetScale(1,1,1)
		end)
		eater:DoTaskInTime(1, function(inst)
			eater.Transform:SetScale(eater.shroomed.scale,eater.shroomed.scale,eater.shroomed.scale)
TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_down")
		end)
	end
	if eater.shroomed.isbigshroomed==false and eater.shroomed.time>0 then
		eater.shroomed.scale=2
		eater.shroomed.issmallshroomed=false
		eater.shroomed.isbigshroomed=true
		eater:DoTaskInTime(0, function(inst)
			eater.Transform:SetScale(eater.shroomed.scale,eater.shroomed.scale,eater.shroomed.scale)
		end)
		eater:DoTaskInTime(.25, function(inst)
			eater.Transform:SetScale(1,1,1)
		end)
		eater:DoTaskInTime(.5, function(inst)
			eater.Transform:SetScale(eater.shroomed.scale,eater.shroomed.scale,eater.shroomed.scale)
		end)
		eater:DoTaskInTime(.75, function(inst)
			eater.Transform:SetScale(1,1,1)
		end)
		eater:DoTaskInTime(1, function(inst)
			eater.Transform:SetScale(eater.shroomed.scale,eater.shroomed.scale,eater.shroomed.scale)
		end)
	end
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBuild("smallmushroom")
    inst.AnimState:SetBank("honey")
    inst.AnimState:PlayAnimation("idle")

	if not TheWorld.ismastersim then return inst end
	inst.entity:SetPristine()
    
    inst:AddComponent("edible")
    inst.components.edible.healthvalue = 0
    inst.components.edible.hungervalue = 0
    inst.components.edible.foodtype = "MEAT"
	inst.components.edible:SetOnEatenFn(oneaten)

	inst:AddComponent("stackable")
	inst.components.stackable.maxsize=10

    inst:AddComponent("tradable")

    inst:AddComponent("inspectable")
    
	inst:AddComponent("perishable")
	inst.components.perishable:SetPerishTime(30*480)
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/smallmushroom.xml"

    return inst
end

return Prefab( "common/inventory/smallmushroom", fn, assets, prefabs) 
